/*
 * =============================  **** DISCLAIMTER ****  ======================================
 *
 * The following code provided by Premiere Global is provided on an "AS IS" basis, without warranty.
 * Neither the authors nor Premiere Global make any representation, or warranty,
 * either express or implied, with respect to this sample program, its quality, accuracy,
 * or fitness for a specific purpose. Therefore, neither the authors nor Premiere Global
 * shall have any liability to you or any other person or entity with respect to any liability,
 * loss, or damage caused or alleged to have been caused directly or indirectly by the program
 * provided by Premiere Global. This includes, but is not limited to, interruption of service,
 * loss of data, loss of profits, or consequential damages from the use of this source code.
 * ============================================================================================
 */

import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

import java.lang.Integer;
import java.lang.String;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.ws.BindingProvider;
//import javax.xml.ws.WebServiceRef;

public class JDTRServlet extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();

        try {
            try { // Call Web Service Operation

                com.premiereconnect.premconn.jobdocumenttransmit._2008._10.XOA service = new com.premiereconnect.premconn.jobdocumenttransmit._2008._10.XOA();
                com.premiereconnect.premconn.jobdocumenttransmit._2008._10.XOASOAPPort port = service.getXOAPort();
                // TODO initialize WS operation arguments here


                // Get user authentication info:
                // Setup XDDSAuth object
                com.premiereconnect.premconn.requestresponse._2008._10.XDDSAuthType XDDSAuth = new com.premiereconnect.premconn.requestresponse._2008._10.XDDSAuthType();
                XDDSAuth.setRequesterID(request.getParameter("user"));
                XDDSAuth.setPassword(request.getParameter("password"));

                // Setup and Assign Authentication Object
                com.premiereconnect.premconn.requestresponse._2008._10.Authentication Auth = new com.premiereconnect.premconn.requestresponse._2008._10.Authentication();
                Auth.setXDDSAuth(XDDSAuth);

                // Get XDN domain & MRN JobId
                com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobIdType JobId = new com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobIdType();
                JobId.setMRN(BigInteger.valueOf(Integer.parseInt(request.getParameter("jobno"))));
                JobId.setXDN(request.getParameter("domain"));

                com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitRequest.JobDocument JobDocument = new com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitRequest.JobDocument();
                JobDocument.setJobId(JobId);

                // Setup and Assign JobDocumentTransmitRequest Object
                com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitRequest parameterJobDocumentTransmitRequest = new com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitRequest();
                parameterJobDocumentTransmitRequest.getJobDocument().add(JobDocument);


                // Need to Adjust the Submit URL because the one listed in the WSDL Port Binding
                // is not a valid reference.  The end of the WSDL uses xoa.xpedite.com however this is not a valid
                // submit URL a valid one isn't posted because PGiConnect has several valid submit URL's
                BindingProvider bp = (BindingProvider) port;
                String address = (String) bp.getRequestContext().get(BindingProvider.ENDPOINT_ADDRESS_PROPERTY);

                com.premiereconnect.premconn.requestresponse._2008._10.Request requestHeader = new com.premiereconnect.premconn.requestresponse._2008._10.Request();
                requestHeader.setAuthentication(Auth);  // Authentication in Header
                do {
                    if (request.getParameter("domain").equals("test2")) {
                        requestHeader.setReceiverKey("http://xoatweb1.xpedite.com/soap/sync"); // Receiver Key in Header
                        address = "http://xoatweb1.xpedite.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                    if (request.getParameter("domain").equals("flusme")) {
                        requestHeader.setReceiverKey("http://xoatweb1.xpedite.com/soap/sync"); // Receiver Key in Header
                        address = "http://xoatweb1.xpedite.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                    if (request.getParameter("domain").equals("pt")) {
                        requestHeader.setReceiverKey("http://xoa.pt.premiereglobal.com/soap/sync"); // Receiver Key in Header
                        address = "http://xoa.pt.premiereglobal.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                    if (request.getParameter("domain").equals("ptmr")) {
                        requestHeader.setReceiverKey("http://xoa.pt.premiereglobal.com/soap/sync"); // Receiver Key in Header
                        address = "http://xoa.pt.premiereglobal.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                    if (request.getParameter("domain").equals("xsi")) {
                        requestHeader.setReceiverKey("https://advance.pgiconnect.com/soap/sync"); // Receiver Key in Header
                        address = "https://advance.pgiconnect.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                    if (request.getParameter("domain").equals("usme")) {
                        requestHeader.setReceiverKey("https://advance.pgiconnect.com/soap/sync"); // Receiver Key in Header
                        address = "https://advance.pgiconnect.com/soap/sync";  // Set URL returns a string value of the submit URL
                        break;
                    }
                } while (false);

                bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, address);

                javax.xml.ws.Holder<com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitResult> parameterJobDocumentTransmitResult = new javax.xml.ws.Holder<com.premiereconnect.premconn.jobdocumenttransmit._2008._10.JobDocumentTransmitResult>();
                javax.xml.ws.Holder<com.premiereconnect.premconn.requestresponse._2008._10.Response> responseHeader = new javax.xml.ws.Holder<com.premiereconnect.premconn.requestresponse._2008._10.Response>();

                out.println("<html>");
                out.println("<head>");

                //Display the report's name as a title in the browser's titlebar:
                out.println("<title>JobDocumentDeliveryRequest</title>");
                out.println("</head>");
                out.println("<body>" +
                        "<p><BLOCKQUOTE>Note, this application returns all the documents related " +
                        "for a specific user and jobID. If the document is not a text file, " +
                        "then the data must be base64 decoded and saved to a file with the " +
                        "appropriate file name extension in order to open correctly.<br>" +
                        "Also, Internet Explorer may not display the data - however the data is there, just not visible. " +
                        "You will need to cut and paste these lines (or view the HTML source) and place them in an editor and then you will see the data.</BLOCKQUOTE><br><br>");

                port.jobDocumentTransmit(parameterJobDocumentTransmitRequest, requestHeader, parameterJobDocumentTransmitResult, responseHeader);
                String StatusMessage = parameterJobDocumentTransmitResult.value.getStatus().getStatusMessage();

                if (parameterJobDocumentTransmitResult.value.getStatus().getStatusCode().equals(BigInteger.ZERO)) {
                    String RecStatus = parameterJobDocumentTransmitResult.value.getJobDocuments().get(0).getRecStatus().getValue();
                    if (!RecStatus.equalsIgnoreCase("ok")) {
                        //Didn't find job #
                        out.println("<h2><font color='red'>Error:<br><br>RecStatus: " + RecStatus + "</font></h2>");
                        out.println("</font></body></html>");
                        out.close();

                    } else {
                        //job found ... return the document(s) ...

                        int docCount = parameterJobDocumentTransmitResult.value.getJobDocuments().get(0).getJobDocumentData().size();
                        out.println("<h2><font color='red'>Docs found: " + docCount + "</font></h2><br><br>");

                        String filename;
                        String docType;
                        String fileData;

                        out.println("<font face=&quot;courier&quot;>");
                        out.println("<br>");
                        out.println("userID: " + request.getParameter("user") + "<br>");
                        out.println("domain: " + request.getParameter("domain") + "<br>");
                        out.println("jobID: &nbsp;" + request.getParameter("jobno") + "<br></font>");


                        for (int i = 0; i < docCount; i++)
                        {
                            filename = parameterJobDocumentTransmitResult.value.getJobDocuments().get(0).getJobDocumentData().get(i).getDocumentInfo().get(0).getFilename();
                            docType = parameterJobDocumentTransmitResult.value.getJobDocuments().get(0).getJobDocumentData().get(i).getDocumentInfo().get(0).getDocType();
                            fileData = parameterJobDocumentTransmitResult.value.getJobDocuments().get(0).getJobDocumentData().get(i).getDocumentInfo().get(0).getFileData().getValue();

                            out.println("<p><br><br>" + (i+1) + ") Filename: " + filename + "<br>");
                            out.println("<p>Filetype: " + docType + "<br>");
                            out.println("<p>Data: <font face=&quot;courier&quot;>" + fileData + "</font><br><br>");
                        }
                    }
                } else {
                    //Generally invalid user credentials if you are here.
                    String ErrorMessage = parameterJobDocumentTransmitResult.value.getStatus().getErrorList().getError().get(0).getErrorMessage();
                    out.println("<h2><font color='red'>Error:<br><br>StatusMessage: " + StatusMessage + "</font></h2>");
                    out.println("<h2><font color='red'>ErrorMessage: " + ErrorMessage + "</font></h2>");
                    out.println("</font></body></html>");
                    out.close();
                }
            } catch (Exception ex) {
                // TODO handle custom exceptions here
                out.println("<title>Error !!!</title>");
                out.println("</head>");
                out.println("<body>");
                out.println("<h2><font color='red'>Exception Error.</font></h2>");
                out.println("</font></body></html>");
                out.close();
            }
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
